'''
Created on 1 nov 2010

@author: Peter
'''
from PyQt4 import QtCore, QtGui, Qt

import math, random

class PADFaceMapped(object):
    '''
    classdocs
    '''
    pupilRandomness=0
    mouthRandomness=0
        
    def __init__(self, x = 0, y = 0, size = 1):
        '''
        Constructor
        '''
        self.size   = size
        # Start variabele is used for reachability of self.mx/my and self.fdx/fdy
        self.start  = True

        self.defineEmotions()
        self.setDimensions(x, y, size)
        self.setEmotion(0, 0, 0, 0, 0)
        
    def defineEmotions(self):
        self.emotions   = []
#        0=-p-a-d     = sad / lonely / bored
#        1=-p-ad     = jealous / disdainful
#        2=-pa-d    = terrified / fearful / humiliated / frustrated
#        3=-pad    = angry / cruel / hostile
#        4=p-a-d    = protected / humble
#        5=p-ad    = leisured / relaxed
#        6=pa-d    = impressed
#        7=pad     = happy / joyful / masterful / excited
#        8=000     = neutral
#        this is the influence sphere of the emotion (used for mixed expressions, standard =1.3)
        self.FACE_MIXTURE_DISTANCE   = []
        self.FACE_MIXTURE_DISTANCE.append(1.3)
        self.FACE_MIXTURE_DISTANCE.append(1.3)
        self.FACE_MIXTURE_DISTANCE.append(1.3)
        self.FACE_MIXTURE_DISTANCE.append(1.3)
        self.FACE_MIXTURE_DISTANCE.append(1.3)
        self.FACE_MIXTURE_DISTANCE.append(1.3)
        self.FACE_MIXTURE_DISTANCE.append(1.3)
        self.FACE_MIXTURE_DISTANCE.append(1.3)
        self.FACE_MIXTURE_DISTANCE.append(1.7)
        
        emotion0        = []
        emotion1        = []
        emotion2        = []
        emotion3        = []
        emotion4        = []
        emotion5        = []
        emotion6        = []
        emotion7        = []
        emotion8        = []

#0        eyes height        
        emotion0.append(-1)
        emotion1.append(-0.3)
        emotion2.append(1)
        emotion3.append(0.5)
        emotion4.append(-1)
        emotion5.append(-0.5)
        emotion6.append(0.3)
        emotion7.append(0.5)
        emotion8.append(0)

#1        eyebrowSpace between eyes and brows
        emotion0.append(-1)
        emotion1.append(0)
        emotion2.append(1)
        emotion3.append(0)
        emotion4.append(-1)
        emotion5.append(0)
        emotion6.append(1)
        emotion7.append(0.5)
        emotion8.append(0)
#2        eyebrowOuter height
        emotion0.append(-1)
        emotion1.append(0)
        emotion2.append(-.8)
        emotion3.append(.8)
        emotion4.append(0)
        emotion5.append(0)
        emotion6.append(0)
        emotion7.append(0)
        emotion8.append(0)
#3        eyebrowInner height
        emotion0.append(1)
        emotion1.append(-1)
        emotion2.append(.8)
        emotion3.append(-.8)
        emotion4.append(0)
        emotion5.append(0)
        emotion6.append(0)
        emotion7.append(0)
        emotion8.append(0)
#4        mouth width
        emotion0.append(-1)
        emotion1.append(-1)
        emotion2.append(0)
        emotion3.append(1)
        emotion4.append(0)
        emotion5.append(0)
        emotion6.append(-1.5)
        emotion7.append(1)
        emotion8.append(0)
#5        mouth openness
        emotion0.append(-1)
        emotion1.append(-0.5)
        emotion2.append(0)
        emotion3.append(1)
        emotion4.append(-1)
        emotion5.append(-0.5)
        emotion6.append(0.5)
        emotion7.append(0.5)
        emotion8.append(-0.5)
#6        mouth twist (positive = happy)
        emotion0.append(-1)
        emotion1.append(-0.5)
        emotion2.append(-0.3)
        emotion3.append(-1)
        emotion4.append(0.7)
        emotion5.append(1)
        emotion6.append(0.5)
        emotion7.append(1)
        emotion8.append(0)
#7        teeth visible 
        emotion0.append(1)
        emotion1.append(1)
        emotion2.append(0.5)
        emotion3.append(1)
        emotion4.append(1)
        emotion5.append(1)
        emotion6.append(-0.5)
        emotion7.append(0.5)
        emotion8.append(1)
#8        p value of emotions
        emotion0.append(-1)
        emotion1.append(-1)
        emotion2.append(-1)
        emotion3.append(-1)
        emotion4.append(1)
        emotion5.append(1)
        emotion6.append(1)
        emotion7.append(1)
        emotion8.append(0)
#9        a value of emotions
        emotion0.append(-1)
        emotion1.append(-1)
        emotion2.append(1)
        emotion3.append(1)
        emotion4.append(-1)
        emotion5.append(-1)
        emotion6.append(1)
        emotion7.append(1)
        emotion8.append(0)
#10        d value of emotions
        emotion0.append(-1)
        emotion1.append(1)
        emotion2.append(-1)
        emotion3.append(1)
        emotion4.append(-1)
        emotion5.append(1)
        emotion6.append(-1)
        emotion7.append(1)
        emotion8.append(0)
        
        self.emotions.append(emotion0)
        self.emotions.append(emotion1)
        self.emotions.append(emotion2)
        self.emotions.append(emotion3)
        self.emotions.append(emotion4)
        self.emotions.append(emotion5)
        self.emotions.append(emotion6)
        self.emotions.append(emotion7)
        self.emotions.append(emotion8)

    def setEmotion(self, p, a, d, mx = 0, my = 0): #accepts pad between -1 and 1
#        some dynamic face positioning based on where the user's mouse pointer is face
#        emotional stuff here
#        first clip the emotion. if p a and d are near the center (abs(p) etc. <.2 then assume 0
        #p = p if math.fabs(p) >= .25 else 0
        #a = a if math.fabs(a) >= .25 else 0
        #d = d if math.fabs(d) >= .25 else 0
#        or put it through a strong sigmoid to enforce emotion choice around the axes
        #p = 2*(-0.5+1/(1+math.exp(-10*p)));
        #a = 2*(-0.5+1/(1+math.exp(-10*a)));
        #d = 2*(-0.5+1/(1+math.exp(-10*d)));
        self.mx = (mx*(self.size/20))/self.size-1 #eye tracking of mouse
        self.my = (my*(self.size/20))/self.size-1 #eye tracking of mouse
        
##        fdx and fdy are the start coordinate of the face within the yellow circle (the skin)
        self.fdy     = self.size/10-int((d+a)*(self.size/20))
        self.fdx     = self.mx
        
#        here a mapping is selected from the predefined 8 emotions in PAD space;
#        and subsequently interpolated.
        emotion = []
        j = 0
        while (j<8):
            weight  = 0;
            i       = 0
            emotion.append(0)
            while i < 9:
                featureWeight   = self.FACE_MIXTURE_DISTANCE[i] - min(self.FACE_MIXTURE_DISTANCE[i], self.distance(p, a, d, self.emotions[i]))
                weight          += featureWeight
                emotion[j]      += featureWeight * self.emotions[i][j]
                i += 1
            emotion[j]  /= weight if weight != 0 else 1
            j += 1
        
        self.eh          = int((self.baseEH * (1 + emotion[0]))+ 2)
        self.eyebrowSpace= int((self.baseEH * (1 + emotion[1]) / 2) + self.baseEH / 2 + 1)
        self.eyebrowOuter= int((-emotion[2] * self.baseEH) / 2)
        self.eyebrowInner= int((-emotion[3] * self.baseEH) / 2)
        
        self.mw  = int((self.baseMW *(emotion[4] + 1) / 6) + self.baseMW / 2)
        self.mo  = int((self.baseMH *(emotion[5] + 1) / 3))
        self.mt  = int((self.baseMH *emotion[6]) / 2)
        
#        teeth visible
        self.tv = int(self.baseMH * (emotion[7] - 1) / 3)
        
    def distance(self, p, a, d, emotion):
        return math.sqrt(math.pow(p - emotion[8], 2) + math.pow(a - emotion[9], 2) + math.pow(d - emotion[10], 2))
    
    def setDimensions(self, xx, yy, size):
        self.sx     = xx
        self.sy     = yy
        self.size   = size
        self.x      = size
        self.y      = size
        
#        Copied from setEmotion, because of reachability issues
#        Made sure it won't be used after running
        if self.start:
            self.mx     = 0 #eye tracking of mouse, cause mx = 0
            self.my     = 0 #eye tracking of mouse, cause my = 0
##           fdx and fdy are the start coordinate of the face within the yellow circle (the skin)
#            Copied from setEmotion, because of reachability issues
            self.fdy     = self.size/10 #cause, d and a are 0
            self.fdx     = self.mx
            self.start  = False
        
        self.baseEW = size / 4
        self.baseEH = self.baseEW / 3
        self.baseMW = size / 2
        self.baseMH = self.baseMW / 3
        
        self.slex   = self.fdx + self.sx + self.size / 2 - int(float(self.baseEW)*1.4)
        self.sley   = self.fdy + self.sy + self.size / 3
        self.srex   = self.fdx + self.sx + self.size / 2 + int(float(self.baseEW)*0.4)
#        self.srex   = self.fdx + self.sx + self.size * 3 / 4 - self.baseEW / 2
        self.srey   = self.fdy + self.sy + self.size / 3
        self.smx    = self.fdx + self.sx + self.size / 2
        self.smy    = self.fdy + self.sy + 2 * (self.size / 3)
        self.x     += self.sx + 20
        self.y     += self.sx + 20
        
    def paint(self, g):
        ''' 
        ATTENTION: Angles must be specified in 1/16th of a degree
        That's why all angles are multiplied by 16
        '''
        if g == None and isinstance(g, QtGui.QPainter):
            return
#        draw pacpan
        pacman      = QtGui.QColor(255,200,0)
        black       = QtGui.QColor(0, 0, 0)
        white       = QtGui.QColor(255, 255, 255)
        
        g.setBrush(QtGui.QBrush(pacman))
        g.setPen(QtCore.Qt.NoPen)

        g.drawEllipse(self.sx + 4, self.sy, self.size - 8, self.size)
        g.drawEllipse(self.sx + 4, self.sy, self.size - 8, int(float(self.size * 0.66)))

#        draw left eye
        pupilVarX   = self.mx + int(self.pupilRandomness * random.random())
        pupilVarY   = self.my + int(self.pupilRandomness * random.random())
        
        g.setBrush(QtGui.QBrush(white))
        g.setPen(QtCore.Qt.NoPen)
        g.drawChord(self.slex, self.sley - self.eh / 2, self.baseEW, self.eh, 0, 360*16)
        
        g.setBrush(QtGui.QBrush(QtGui.QColor(0,200,200)))
        g.setPen(QtCore.Qt.NoPen)
        g.drawChord(pupilVarX + self.slex + self.baseEW / 2 - self.baseEW / 4, pupilVarY + self.sley - self.baseEW / 4, self.baseEW / 2, self.baseEW / 2, 0, 360*16)

        g.setBrush(QtGui.QBrush(black))
        g.setPen(QtCore.Qt.NoPen)
        g.drawChord(pupilVarX + self.slex + self.baseEW / 2 - self.baseEW / 10, pupilVarY + self.sley - self.baseEW / 10, self.baseEW / 5, self.baseEW / 5, 0, 360*16)
        
        g.setBrush(QtGui.QBrush(pacman))
        g.setPen(QtCore.Qt.NoPen)
        g.fillRect(self.slex, self.sley - self.eh / 2 - self.baseEW / 2, self.baseEW, self.baseEW / 2, pacman)
        g.fillRect(self.slex, self.sley + self.eh / 2, self.baseEW, self.baseEW / 2, pacman)
        
#        left eyebrow
        g.setPen(black)
        g.drawLine(self.slex, self.sley - self.eyebrowSpace + self.eyebrowOuter, self.slex + self.baseEW, self.sley - self.eyebrowSpace + self.eyebrowInner)
        g.drawLine(self.slex, 1 + self.sley - self.eyebrowSpace + self.eyebrowOuter, self.slex + self.baseEW, 1 + self.sley - self.eyebrowSpace + self.eyebrowInner)
        if (self.size>70):
            g.drawLine(self.slex, 2 + self.sley - self.eyebrowSpace + self.eyebrowOuter, self.slex + self.baseEW, 2 + self.sley - self.eyebrowSpace + self.eyebrowInner)
        
#        draw right eye
        pupilVarX   = self.mx + int(self.pupilRandomness * random.random())
        pupilVarY   = self.my + int(self.pupilRandomness * random.random())
        
        g.setBrush(QtGui.QBrush(white))
        g.setPen(QtCore.Qt.NoPen)
        g.drawChord(self.srex, self.srey - self.eh / 2, self.baseEW, self.eh, 0, 360*16)
        
        g.setBrush(QtGui.QBrush(QtGui.QColor(0,200,200)))
        g.setPen(QtCore.Qt.NoPen)
        g.drawChord(pupilVarX + self.srex + self.baseEW / 2 - self.baseEW / 4, pupilVarY + self.srey - self.baseEW / 4, self.baseEW / 2, self.baseEW / 2, 0, 360*16)
        
        g.setBrush(QtGui.QBrush(black))
        g.setPen(QtCore.Qt.NoPen)
        g.drawChord(pupilVarX + self.srex + self.baseEW / 2 - self.baseEW / 10, pupilVarY + self.srey - self.baseEW / 10, self.baseEW / 5, self.baseEW / 5, 0, 360*16)

        g.setBrush(QtGui.QBrush(pacman))
        g.setPen(QtCore.Qt.NoPen)
        g.fillRect(self.srex, self.srey - self.eh / 2 - self.baseEW / 2, self.baseEW, self.baseEW / 2, pacman)
        g.fillRect(self.srex, self.srey + self.eh / 2, self.baseEW, self.baseEW / 2, pacman)
        
#        right eyebrow
        g.setPen(black) #black);
        g.drawLine(self.srex, self.srey - self.eyebrowSpace + self.eyebrowInner, self.srex + self.baseEW, self.srey - self.eyebrowSpace + self.eyebrowOuter)
        g.drawLine(self.srex, 1 + self.srey - self.eyebrowSpace + self.eyebrowInner, self.srex + self.baseEW, 1 + self.srey - self.eyebrowSpace + self.eyebrowOuter)
        if (self.size>70):
            g.drawLine(self.srex, 2 + self.srey - self.eyebrowSpace + self.eyebrowInner, self.srex + self.baseEW, 2 + self.srey - self.eyebrowSpace + self.eyebrowOuter)
        
#        draw mouth
#        draw lips
        mr      = int(self.mouthRandomness * random.random())
        upperlip= self.mt - self.mo
        lowerlip= self.mt + self.mo
        shift   = -self.mt
       
#        fill the mouth in the right order
        if (upperlip > 0):
            if (lowerlip > 0):
                g.setBrush(QtGui.QBrush(white))
                g.setPen(QtCore.Qt.NoPen)
                g.drawChord(self.smx - self.mw / 2, shift + mr + self.smy-lowerlip, self.mw, lowerlip * 2, -180*16, 180*16)
            else:
                g.setBrush(QtGui.QBrush(pacman))
                g.setPen(QtCore.Qt.NoPen)
                g.drawChord(self.smx - self.mw / 2, shift + mr + self.smy + lowerlip, self.mw, -lowerlip * 2, 0, 180*16)
            g.setBrush(QtGui.QBrush(pacman))
            g.setPen(QtCore.Qt.NoPen)
            g.drawChord(self.smx - self.mw / 2, shift + mr + self.smy - upperlip, self.mw, upperlip * 2, -180*16, 180*16)
        else:
            g.setBrush(QtGui.QBrush(white))
            g.setPen(QtCore.Qt.NoPen)
            g.drawChord(self.smx - self.mw / 2, shift + mr + self.smy + upperlip, self.mw, -upperlip * 2, 0, 180*16)
            if (lowerlip>0):
                g.setBrush(QtGui.QBrush(white))
                g.setPen(QtCore.Qt.NoPen)
                g.drawChord(self.smx - self.mw / 2, shift + mr + self.smy - lowerlip, self.mw, lowerlip * 2, -180*16, 180*16)
            else:
                g.setBrush(QtGui.QBrush(pacman))
                g.setPen(QtCore.Qt.NoPen)
                g.drawChord(self.smx - self.mw / 2, shift + mr + self.smy + lowerlip, self.mw, -lowerlip * 2, 0, 180*16)
        
        
#        fill mouth hole
        g.fillRect(self.smx - self.mw / 2, self.smy + self.tv, self.mw, -self.tv*2, pacman)

#      draw teeth
        g.setPen(pacman)
        i = 0
        while (i<6):
            g.drawLine(self.smx - self.baseMW / 2 + i * self.baseMW / 5, self.smy - math.fabs(self.mt) - self.mo, self.smx - self.baseMW / 2 + i * self.baseMW / 5, self.smy + math.fabs(self.mt) + self.mo)
            i += 1
        g.drawLine(self.smx - self.baseMW / 2, self.smy, self.smx + self.baseMW / 2, self.smy)
        
        
#        draw red lips
        g.setBrush(QtCore.Qt.NoBrush)
        g.setPen(QtGui.QColor(200,100,0))
        if (upperlip>0):
            g.drawArc(self.smx - self.mw / 2, shift + mr + self.smy - upperlip, self.mw, upperlip * 2, -180*16, 180*16);
        else:
            g.drawArc(self.smx - self.mw / 2, shift + mr + self.smy + upperlip, self.mw, -upperlip * 2, 0, 180*16);
        
        if (lowerlip>0):
            g.drawArc(self.smx - self.mw/2, shift + mr + self.smy - lowerlip, self.mw, lowerlip * 2, -180*16, 180*16);
        else:
            g.drawArc(self.smx-self.mw / 2, shift + mr + self.smy + lowerlip, self.mw, -lowerlip * 2, 0, 180*16);
        g.end()